- download and use i18n/Index to choose which Translations to download
[ntk/apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
3# we all like colorful messages
4CERROR="\e[1;31m" # red
5CWARNING="\e[1;33m" # yellow
6CMSG="\e[1;32m" # green
7CINFO="\e[1;96m" # light blue
8CDEBUG="\e[1;94m" # blue
9CNORMAL="\e[0;39m" # default system console color
10CDONE="\e[1;32m" # green
11CPASS="\e[1;32m" # green
12CFAIL="\e[1;31m" # red
13CCMD="\e[1;35m" # pink
14
15msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
18msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25msgtest() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
29
30# enable / disable Debugging
fc89263e
DK
31MSGLEVEL=${MSGLEVEL:-3}
32if [ $MSGLEVEL -le 0 ]; then
33 msgdie() { true; }
34fi
35if [ $MSGLEVEL -le 1 ]; then
36 msgwarn() { true; }
37 msgnwarn() { true; }
38fi
39if [ $MSGLEVEL -le 2 ]; then
40 msgmsg() { true; }
41 msgnmsg() { true; }
39cc8228
DK
42 msgtest() { true; }
43 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
44 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
45 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
fc89263e
DK
46fi
47if [ $MSGLEVEL -le 3 ]; then
48 msginfo() { true; }
49 msgninfo() { true; }
50fi
51if [ $MSGLEVEL -le 4 ]; then
52 msgdebug() { true; }
53 msgndebug() { true; }
54fi
55msgdone() {
56 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
57 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
58 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
59 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
60 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
61 true;
62 else
63 echo "${CDONE}DONE${CNORMAL}" >&2;
64 fi
65}
8d876415
DK
66
67runapt() {
68 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
7d0627b6
DK
69 if [ -f ./aptconfig.conf ]; then
70 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
4b2a4ab8
MV
71 elif [ -f ../aptconfig.conf ]; then
72 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
7d0627b6
DK
73 else
74 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
75 fi
8d876415
DK
76}
77aptconfig() { runapt apt-config $*; }
78aptcache() { runapt apt-cache $*; }
79aptget() { runapt apt-get $*; }
80aptftparchive() { runapt apt-ftparchive $*; }
1f8b2599 81aptkey() { runapt apt-key $*; }
158fda31
DK
82dpkg() {
83 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
84}
b6b5a542
DK
85aptitude() {
86 if [ -f ./aptconfig.conf ]; then
87 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
88 elif [ -f ../aptconfig.conf ]; then
89 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
90 else
91 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
92 fi
93}
8d876415 94
b720d0bd
DK
95addtrap() {
96 CURRENTTRAP="$CURRENTTRAP $1"
97 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
98}
99
8d876415 100setupenvironment() {
75954ae2 101 TMPWORKINGDIRECTORY=$(mktemp -d)
8f8169ac 102 local TESTDIR=$(readlink -f $(dirname $0))
3cbbda3c 103 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
8f8169ac 104 BUILDDIRECTORY="${TESTDIR}/../../build/bin"
8d876415
DK
105 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
106 local OLDWORKINGDIRECTORY=$(pwd)
b720d0bd 107 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
8d876415 108 cd $TMPWORKINGDIRECTORY
cd725954 109 mkdir rootdir aptarchive keys
8d876415 110 cd rootdir
b29c3712
DK
111 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
112 mkdir -p var/cache var/lib var/log
cffea9af 113 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
2c6baa5a 114 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
8f8169ac
DK
115 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
116 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
117 else
118 touch var/lib/dpkg/status
119 fi
cd725954 120 touch var/lib/dpkg/available
8d876415
DK
121 mkdir -p usr/lib/apt
122 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
123 cd ..
2c6baa5a 124 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
8f8169ac
DK
125 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
126 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 127 fi
4a4ea26c
AM
128 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
129 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
130 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
4a4ea26c 131 fi
cd725954
DK
132 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
133 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
cffea9af 134 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 135 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415
DK
136 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
137 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
f425d4d5 138 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
cffea9af
DK
139 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
140 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
141 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
142 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
143 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
144 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
2c085486 145 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
8d876415
DK
146 export LC_ALL=C
147 msgdone "info"
148}
149
150configarchitecture() {
151 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
152 echo "APT::Architecture \"$1\";" > $CONFFILE
153 shift
154 while [ -n "$1" ]; do
155 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
156 shift
157 done
158}
159
75954ae2 160setupsimplenativepackage() {
ce9864a8
DK
161 local NAME="$1"
162 local ARCH="$2"
163 local VERSION="$3"
164 local RELEASE="${4:-unstable}"
165 local DEPENDENCIES="$5"
166 local DESCRIPTION="$6"
b7899b00
DK
167 local SECTION="${7:-others}"
168 local DISTSECTION
169 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
170 DISTSECTION="main"
171 else
172 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
173 fi
ce9864a8
DK
174 local BUILDDIR=incoming/${NAME}-${VERSION}
175 mkdir -p ${BUILDDIR}/debian/source
176 cd ${BUILDDIR}
177 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
178 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
179 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
180
181 * Initial release
182
b7899b00
DK
183 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
184 test -e debian/control || echo "Source: $NAME
185Section: $SECTION
ce9864a8
DK
186Priority: optional
187Maintainer: Joe Sixpack <joe@example.org>
188Build-Depends: debhelper (>= 7)
189Standards-Version: 3.9.1
190
191Package: $NAME
b7899b00 192Architecture: $ARCH" > debian/control
ce9864a8
DK
193 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
194 if [ -z "$DESCRIPTION" ]; then
195 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
196 If you find such a package installed on your system,
197 YOU did something horribly wrong! They are autogenerated
198 und used only by testcases for APT and surf no other propose…" >> debian/control
199 else
200 echo "Description: $DESCRIPTION" >> debian/control
201 fi
b7899b00
DK
202 test -e debian/compat || echo "7" > debian/compat
203 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 204 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
205 cd - > /dev/null
206}
207
208buildsimplenativepackage() {
209 local NAME="$1"
210 local ARCH="$2"
211 local VERSION="$3"
212 local RELEASE="${4:-unstable}"
213 local DEPENDENCIES="$5"
214 local DESCRIPTION="$6"
215 local SECTION="${7:-others}"
216 local DISTSECTION
217 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
218 DISTSECTION="main"
219 else
220 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
221 fi
b761356f
DK
222 local BUILDDIR=incoming/${NAME}-${VERSION}
223
18331adf 224 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
b761356f
DK
225 mkdir -p $BUILDDIR/debian/source
226 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
227 echo "#!/bin/sh
228echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
229
230 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
231 echo "$NAME ($VERSION) $RELEASE; urgency=low
232
233 * Initial release
234
235 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
236 echo "Source: $NAME
237Section: $SECTION
238Priority: optional
239Maintainer: Joe Sixpack <joe@example.org>
240Standards-Version: 3.9.1
241
242Package: $NAME
243Architecture: $ARCH" > ${BUILDDIR}/debian/control
244 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
245 if [ -z "$DESCRIPTION" ]; then
246 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
247 If you find such a package installed on your system,
248 YOU did something horribly wrong! They are autogenerated
249 und used only by testcases for APT and surf no other propose…" >> ${BUILDDIR}/debian/control
250 else
251 echo "Description: $DESCRIPTION" >> ${BUILDIR}/debian/control
252 fi
253 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
254 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
255
256 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
257 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
258 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
259 (cd ${BUILDDIR}; dpkg-gencontrol)
260 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
261
262 dpkg-deb --build ${BUILDDIR}/debian/tmp incoming > /dev/null
263 echo "pool/${NAME}_${VERSION}_${ARCH}.deb" >> incoming/${RELEASE}.${DISTSECTION}.pkglist
264 for SRC in $SRCS; do
265 echo "pool/${SRC}" >> incoming/${RELEASE}.${DISTSECTION}.srclist
266 done
75954ae2 267 rm -rf "incoming/${NAME}-${VERSION}"
b761356f 268 msgdone "info"
75954ae2
DK
269}
270
271buildpackage() {
272 local BUILDDIR=$1
273 local RELEASE=$2
274 local SECTION=$3
275 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
276 cd $BUILDDIR
277 if [ "$ARCH" = "all" ]; then
278 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
279 fi
b7899b00
DK
280 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
281 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
5ed56f93 282 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 283 cd - > /dev/null
b7899b00 284 for PKG in $PKGS; do
75954ae2 285 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
286 done
287 for SRC in $SRCS; do
75954ae2 288 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 289 done
cffea9af 290 msgdone "info"
ce9864a8
DK
291}
292
293buildaptarchive() {
ce9864a8
DK
294 if [ -d incoming ]; then
295 buildaptarchivefromincoming $*
296 else
297 buildaptarchivefromfiles $*
298 fi
299}
300
301createaptftparchiveconfig() {
302 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
158fda31
DK
303 if [ -z "$ARCHS" ]; then
304 # the pool is empty, so we will operate on faked packages - let us use the configured archs
305 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
306 fi
ce9864a8
DK
307 echo -n 'Dir {
308 ArchiveDir "' >> ftparchive.conf
309 echo -n $(readlink -f .) >> ftparchive.conf
310 echo -n '";
311 CacheDir "' >> ftparchive.conf
312 echo -n $(readlink -f ..) >> ftparchive.conf
313 echo -n '";
b7899b00
DK
314 FileListDir "' >> ftparchive.conf
315 echo -n $(readlink -f pool/) >> ftparchive.conf
316 echo -n '";
317};
318Default {
319 Packages::Compress ". gzip bzip2 lzma";
320 Sources::Compress ". gzip bzip2 lzma";
321 Contents::Compress ". gzip bzip2 lzma";
18331adf
DK
322 Translation::Compress ". gzip bzip2 lzma";
323 LongDescription "false";
ce9864a8
DK
324};
325TreeDefault {
326 Directory "pool/";
327 SrcDirectory "pool/";
328};
329APT {
330 FTPArchive {
331 Release {
332 Origin "joesixpack";
333 Label "apttestcases";
334 Suite "unstable";
335 Description "repository with dummy packages";
336 Architectures "' >> ftparchive.conf
337 echo -n "$ARCHS" >> ftparchive.conf
338 echo 'source";
339 };
340 };
341};' >> ftparchive.conf
b7899b00
DK
342 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
343 echo -n 'tree "dists/' >> ftparchive.conf
344 echo -n "$DIST" >> ftparchive.conf
345 echo -n '" {
ce9864a8
DK
346 Architectures "' >> ftparchive.conf
347 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
348 echo -n 'source";
349 FileList "' >> ftparchive.conf
350 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
351 echo -n '";
352 SourceFileList "' >> ftparchive.conf
353 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
354 echo -n '";
355 Sections "' >> ftparchive.conf
356 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
357 echo '";
ce9864a8 358};' >> ftparchive.conf
b7899b00 359 done
ce9864a8
DK
360}
361
362buildaptftparchivedirectorystructure() {
b7899b00
DK
363 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
364 for DIST in $DISTS; do
365 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
366 for SECTION in $SECTIONS; do
367 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
368 for ARCH in $ARCHS; do
369 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
370 done
371 mkdir -p dists/${DIST}/${SECTION}/source
372 mkdir -p dists/${DIST}/${SECTION}/i18n
373 done
ce9864a8 374 done
ce9864a8
DK
375}
376
9b78cda6
DK
377insertpackage() {
378 local RELEASE="$1"
379 local NAME="$2"
380 local ARCH="$3"
381 local VERSION="$4"
382 local DEPENDENCIES="$5"
383 local ARCHS="$ARCH"
384 if [ "$ARCHS" = "all" ]; then
385 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
386 fi
387 for BUILDARCH in $ARCHS; do
388 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
389 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
390 touch aptarchive/dists/${RELEASE}/main/source/Sources
391 local FILE="${PPATH}/Packages"
392 echo "Package: $NAME
393Priority: optional
394Section: other
2c085486 395Installed-Size: 42
9b78cda6
DK
396Maintainer: Joe Sixpack <joe@example.org>
397Architecture: $ARCH
2c085486
DK
398Version: $VERSION
399Filename: pool/main/${NAME}/${NAME}_${VERSION}_${ARCH}.deb" >> $FILE
9b78cda6
DK
400 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
401 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
402 If you find such a package installed on your system,
403 YOU did something horribly wrong! They are autogenerated
404 und used only by testcases for APT and surf no other propose…
405" >> $FILE
406 done
407}
408
ce9864a8 409buildaptarchivefromincoming() {
3cbbda3c 410 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
411 cd aptarchive
412 [ -e pool ] || ln -s ../incoming pool
413 [ -e ftparchive.conf ] || createaptftparchiveconfig
414 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 415 msgninfo "\tGenerate Packages, Sources and Contents files… "
ce9864a8 416 aptftparchive -qq generate ftparchive.conf
ce9864a8
DK
417 cd - > /dev/null
418 msgdone "info"
9b78cda6 419 generatereleasefiles
ce9864a8
DK
420}
421
422buildaptarchivefromfiles() {
3cbbda3c 423 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
9b78cda6
DK
424 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
425 msgninfo "\t${line} file… "
426 cat ${line} | gzip > ${line}.gz
427 cat ${line} | bzip2 > ${line}.bz2
428 cat ${line} | lzma > ${line}.lzma
8d876415 429 msgdone "info"
9b78cda6
DK
430 done
431 generatereleasefiles
432}
433
434generatereleasefiles() {
435 msgninfo "\tGenerate Release files… "
fe0f7911 436 local DATE="${1:-now}"
9b78cda6 437 if [ -e aptarchive/dists ]; then
18331adf
DK
438 for dir in $(find ./aptarchive/dists -mindepth 3 -maxdepth 3 -type d -name 'i18n'); do
439 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Patterns::='Translation-*' > $dir/Index
440 done
9b78cda6 441 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
35faae11 442 local CODENAME="$(echo "$dir" | cut -d'/' -f 4)"
2c085486
DK
443 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Suite="${CODENAME}" -o APT::FTPArchive::Release::Codename="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
444 if [ "$CODENAME" = "experimental" -o "$CODENAME" = "experimental2" ]; then
35faae11
DK
445 sed -i '/^Date: / a\
446NotAutomatic: yes' $dir/Release
447 fi
9b78cda6
DK
448 done
449 else
450 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 451 fi
fe0f7911
DK
452 if [ "$DATE" != "now" ]; then
453 for release in $(find ./aptarchive -name 'Release'); do
454 touch -d "$1" $release
455 done
456 fi
b7899b00 457 msgdone "info"
8d876415
DK
458}
459
b7899b00
DK
460setupdistsaptarchive() {
461 local APTARCHIVE=$(readlink -f ./aptarchive)
462 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
463 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
464 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
465 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
466 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
467 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
468 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
469 msgdone "info"
470 done
471}
472
473setupflataptarchive() {
ce9864a8 474 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
475 if [ -f ${APTARCHIVE}/Packages ]; then
476 msgninfo "\tadd deb sources.list line… "
477 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
478 msgdone "info"
479 else
480 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
481 fi
482 if [ -f ${APTARCHIVE}/Sources ]; then
483 msgninfo "\tadd deb-src sources.list line… "
484 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
485 msgdone "info"
486 else
487 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
488 fi
b7899b00
DK
489}
490
491setupaptarchive() {
492 buildaptarchive
493 if [ -e aptarchive/dists ]; then
494 setupdistsaptarchive
495 else
496 setupflataptarchive
497 fi
f213b6ea 498 signreleasefiles
cd725954 499 msgninfo "\tSync APT's cache with the archive… "
8d876415 500 aptget update -qq
cd725954 501 msgdone "info"
8d876415
DK
502}
503
f213b6ea
DK
504signreleasefiles() {
505 local SIGNER="${1:-Joe Sixpack}"
506 msgninfo "\tSign archive with $SIGNER key… "
507 local SECKEYS=""
508 for KEY in $(find keys/ -name '*.sec'); do
509 SECKEYS="$SECKEYS --secret-keyring $KEY"
510 done
511 local PUBKEYS=""
512 for KEY in $(find keys/ -name '*.pub'); do
513 PUBKEYS="$PUBKEYS --keyring $KEY"
514 done
515 for RELEASE in $(find aptarchive/ -name Release); do
516 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
fe0f7911 517 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
f213b6ea
DK
518 done
519 msgdone "info"
520}
521
522changetowebserver() {
523 if which weborf > /dev/null; then
524 weborf -xb aptarchive/ 2>&1 > /dev/null &
b720d0bd 525 addtrap "kill $!;"
f213b6ea
DK
526 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
527 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
528 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
529 done
530 return 0
531 fi
532 return 1
533}
534
535checkdiff() {
8d876415
DK
536 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
537 if [ -n "$DIFFTEXT" ]; then
538 echo
539 echo "$DIFFTEXT"
540 return 1
541 else
542 return 0
543 fi
544}
545
75954ae2
DK
546testfileequal() {
547 local FILE="$1"
548 shift
549 msgtest "Test for correctness of file" "$FILE"
550 if [ -z "$*" ]; then
f213b6ea 551 echo -n "" | checkdiff $FILE - && msgpass || msgfail
75954ae2 552 else
f213b6ea 553 echo "$*" | checkdiff $FILE - && msgpass || msgfail
75954ae2
DK
554 fi
555}
556
8d876415
DK
557testequal() {
558 local COMPAREFILE=$(mktemp)
b720d0bd 559 addtrap "rm $COMPAREFILE;"
8d876415
DK
560 echo "$1" > $COMPAREFILE
561 shift
562 msgtest "Test for equality of" "$*"
f213b6ea 563 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
564}
565
685625bd
DK
566testequalor2() {
567 local COMPAREFILE1=$(mktemp)
568 local COMPAREFILE2=$(mktemp)
569 local COMPAREAGAINST=$(mktemp)
b720d0bd 570 addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
685625bd
DK
571 echo "$1" > $COMPAREFILE1
572 echo "$2" > $COMPAREFILE2
573 shift 2
574 msgtest "Test for equality OR of" "$*"
575 $* 2>&1 1> $COMPAREAGAINST
f213b6ea
DK
576 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
577 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
578 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
579 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
685625bd
DK
580 msgfail )
581}
582
8d876415 583testshowvirtual() {
4bec02c2 584 local VIRTUAL="N: Can't select versions from package '$1' as it purely virtual"
8d876415
DK
585 local PACKAGE="$1"
586 shift
587 while [ -n "$1" ]; do
588 VIRTUAL="${VIRTUAL}
4bec02c2 589N: Can't select versions from package '$1' as it purely virtual"
8d876415
DK
590 PACKAGE="${PACKAGE} $1"
591 shift
592 done
593 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
594 VIRTUAL="${VIRTUAL}
4bec02c2 595N: No packages found"
8d876415 596 local COMPAREFILE=$(mktemp)
b720d0bd 597 addtrap "rm $COMPAREFILE;"
8d876415
DK
598 local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
599 eval `apt-config shell ARCH APT::Architecture`
600 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 601 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
602}
603
604testnopackage() {
605 msgtest "Test for non-existent packages" "apt-cache show $*"
606 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
607 if [ -n "$SHOWPKG" ]; then
608 echo
609 echo "$SHOWPKG"
610 msgfail
611 return 1
612 fi
613 msgpass
614}
01a6e24c
DK
615
616testdpkginstalled() {
617 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
618 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^i]' | wc -l)"
619 if [ "$PKGS" != 0 ]; then
620 echo $PKGS
621 dpkg -l $* | grep '^[a-z]'
622 msgfail
623 return 1
624 fi
625 msgpass
626}
627
628testdpkgnoninstalled() {
629 msgtest "Test for correctly non-installed package(s) with" "dpkg -l $*"
630 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^u]' | wc -l)"
631 if [ "$PKGS" != 0 ]; then
632 echo
633 dpkg -l $* | grep '^[a-z]'
634 msgfail
635 return 1
636 fi
637 msgpass
638}